#! /bin/bash

###############################################################################
#    Webmin Sysstats - network.sh
#
#    Webmin Sysstats Module 
#    Copyright (C) 2001 by David Bouius
#    Bug reports to: dbouius@users.sourceforge.net
#    $Id: network.sh,v 1.7 2001/12/07 10:53:48 gerbier Exp $
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
###############################################################################

. ../../config
. ./network.cfg

let d=1

while [ $d != 0 ]
do
   net_var="net$d"

   # bash 2 syntaxe
   # net_name="${!net_var}"

   # bash 1 syntaxe 
   eval net_name=\$${net_var}

   if [ -z "$net_name" ]
   then
      exit
   else
      values=$(grep $net_name /proc/net/dev | cut -b8-)
      outbytes=$(echo $values | awk '{print $9}')
      inbytes=$(echo $values | awk '{print $1}')

      cobytes=$(echo $values | awk '{print $14}')
      erinbytes=$(echo $values | awk '{print $3 + $4 + $5 + $6}')
      eroutbytes=$(echo $values | awk '{print $11 + $12 + $13 + $15}')
   fi

   if [ -n "$outbytes" ]
   then
	$rrdtool update ${rrdtables}${net_name}.rrd N:$inbytes:$outbytes:$erinbytes:$eroutbytes:$cobytes
   fi

   let d=d+1
done
